<?php
/*
 * $RCSfile: mapItemEdit.inc,v $Revision: 1.26 $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */

/**
 * @version 0.5.1a
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 */

GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');

/**
 * This controller will handle assigning values to custom fields
 *
 * @package map
 * @subpackage UserInterface
 *
 */
class mapItemEdit extends ItemEditPlugin {

    /**
     * @see ItemEditPlugin::handleRequest
     */
    function handleRequest($form, &$item, &$preferred) {
        global $gallery;
        $gurl=&$gallery->getUrlGenerator();

	$status = null;
	$error = array();
	list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
        if ($ret) {
	      return $ret->wrap(__FILE__, __LINE__);
        }

	if (isset($form['cfAdmin'])) {
	    list ($ret, $adminStatus) = mapHelper::handleAdminAction($form, $item->getId());
            if ($ret) {
	      return $ret->wrap(__FILE__, __LINE__);
            }
	    foreach ($adminStatus as $key => $tmp) {
		switch ($key) {
		case 'saved':
		    $status = $gallery->i18n("Display settings saved successfully");
		    break;
		case 'added':
		    $status = $gallery->i18n("New field added successfully");
		    break;
		case 'moved':
		    $status = $gallery->i18n("Field moved successfully");
		    break;
		case 'removed':
		    $status = $gallery->i18n("Field removed successfully");
		    break;
		case 'picklist':
		    $status = $gallery->i18n("Picklist updated successfully");
		    break;
		case 'error':
		    $status = '<div class="giError">' .
			$gallery->i18n("Field name already in use") . '</div>';
		    break;
		default:
		    $status = $key;
		}
	    }
	} else if (isset($form['action']['save'])) {
	    //error control
	    if (!preg_match('/^([-+]?(([0-9]{1,3}(\.[0-9]{0,20})?)|(\.[0-9]{1,19}))(\040)*,(\040)*[-+]?(([0-9]{1,3}(\.[0-9]{0,20})?)|(\.[0-9]{1,19})))?$/',$form['fields']['GPS']))
            {
              $status = '<span class="giError">Bad Coordinates, Please Verify</span>';
            } else {
              //cleanup the coordinates of any spaces
              if ($form['fields']['GPS'] != "") $form['fields']['GPS'] = str_replace(" ","",trim($form['fields']['GPS']));

              if (($form['fields']['ZoomLevel']!="") and ($form['fields']['ZoomLevel']==0)) $form['fields']['ZoomLevel']="0.0";              $ret = mapHelper::saveFieldValues($item, $form['fields']);
              if ($ret) {
                   return $ret->wrap(__FILE__, __LINE__);
              }
      	      list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
              if ($ret) {
                   return $ret->wrap(__FILE__, __LINE__);
              }
      	      $status = $gallery->i18n('Changes saved successfully');
	    }
	} elseif (isset($form['action']['getexif'])){

          $form['fields']['GPS'] = $form['exif'];
          $ret = mapHelper::saveFieldValues($item, $form['fields']);
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }
	  list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }

	  $status = $gallery->i18n('GPS coordinate successfully entered and saved');

        } elseif (isset($form['action']['getcoord'])) { //Get coordinates from address

          // This code is courtesy of Arthur Louie (http://www.alouie.com)

          $correctedaddress = urlencode($form['address']);
          $url = "http://maps.google.com/maps?q=".$correctedaddress."&output=js";
          $file="";
          @$filepointer = fopen($url,"r");
          if($filepointer){
          while(!feof($filepointer)){
             $buffer = fgets($filepointer, 4096);
             $file .= $buffer;
          }
          fclose($filepointer);
          } else {
          die($module->translate("Cannnot get info from Google Maps"));
          }
          preg_match('/viewport: \{center: \{lat: (.*),lng: (.*)\},span/',$file,$match);
          $coords = $match[2].",".$match[1];
          $form['fields']['GPS'] = $coords;

          //warning if coordinates aren't found, it defaults to -95.677068,37.062500s
          $ret = mapHelper::saveFieldValues($item, $form['fields']);
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }
	  list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }

	  $status = $gallery->i18n('GPS coordinate successfully entered and saved');
        }

	return array(null, $error, $status);
    }

    /**
     * @see ItemEditPlugin::loadTemplate
     */
    function loadTemplate(&$template, &$form, $item, $thumbnail) {
	global $gallery;
	$session =& $gallery->getSession();
	$tmp = $session->get(CUSTOM_FIELD_SESSION_KEY);
	$adminMode = (!empty($tmp) && $tmp == $item->getId()) ? 1 : 0;

	if ($form['formName'] != 'mapItemEdit') {
	    $form['formName'] = 'mapItemEdit';
	    $form['itemId'] = $item->getId();
	}

        $id=$form['itemId'];
        $urlGenerator =& $gallery->getUrlGenerator();
 	  $url = $urlGenerator->generateUrl(array('view' => 'core.DownloadItem',
						    'itemId' => $id));
        $file = explode("?",$url);

        $ids[] = $id;

        $version = GalleryCoreApi::getPluginParameter('module','map','oldexifversion');
        $form['oldexifversion']=$version[1];

        list ($ret, $exif) = GalleryCoreApi::newFactoryInstance('ExifInterface_1_0');
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
        }
        if (isset($exif)) {
          list ($ret, $exifData) = $exif->getMetaData($ids);
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }

        if (array_key_exists($id,$exifData)) {
          if (array_key_exists('GPS/Latitude',$exifData[$id]) and array_key_exists('GPS/Longitude',$exifData[$id]) and array_key_exists('GPS/LatitudeReference',$exifData[$id]) and array_key_exists('GPS/LongitudeReference',$exifData[$id]))
          {
            $lat = explode(" ",str_replace(",",".",$exifData[$id]['GPS/Latitude']['value']));
            $lon = explode(" ",str_replace(",",".",$exifData[$id]['GPS/Longitude']['value']));
            if ((count($lat)<3) || (count($lon)<3)) $form['invalidgpsformat']=1;
            $Glatitude = $lat[0] + (isset($lat[1]) ? $lat[1]/60 : 0) + (isset($lat[2]) ? $lat[2]/3600 : 0);
            $Glatitude = ($exifData[$id]['GPS/LatitudeReference']['value']=="N") ? $Glatitude:-$Glatitude;
            $Glatitude = str_replace(",",".",$Glatitude);
            $Glongitude = $lon[0] + (isset($lon[1]) ? $lon[1]/60 : 0) + (isset($lon[2]) ? $lon[2]/3600 : 0);
            $Glongitude = ($exifData[$id]['GPS/LongitudeReference']['value']=="E") ? $Glongitude:-$Glongitude;
            $Glongitude = str_replace(",",".",$Glongitude);
            $coordinates = $Glatitude.",".$Glongitude;
          }
        }                                          
        }
        if (isset($coordinates)) $form['exif']=$coordinates;


	switch ($adminMode) {
	case 1:
	    $ret = mapHelper::loadAdminForm($form, $item->getId());
            if ($ret) {
		return array($ret->wrap(__FILE__, __LINE__), null, null);
            }
	    $tpl = 'modules/map/templates/mapItemAdmin.tpl';
	    break;
	default:
	    $set = GalleryUtilities::isA($item, 'GalleryAlbumItem') ? 'album'
		 : (GalleryUtilities::isA($item, 'GalleryPhotoItem') ? 'photo' : 'common');
	    list ($ret, $tmp, $param, $isContainerSettings) =
		mapHelper::fetchFieldValues(array($item), null, $set);
            if ($ret) {
		return array($ret->wrap(__FILE__, __LINE__), null, null);
            }
	    $form['fields'] = $tmp[$item->getId()];
	    foreach (array('common' => 1, $set => 1) as $s => $tmp) {
		foreach ($param[$item->getId()][$s] as $it) {
		    if (!empty($it['choices'])) {
			$form['choices'][$it['field']] = $it['choices'];
		    }
		}
	    }
	    if ($set == 'album') {
		$form['adminFlag'] = $isContainerSettings[$item->getId()] ? 1 : 2;
	    }
	    $tpl = 'modules/map/templates/mapItemEdit.tpl';
	}
	$template->setVariable('controller', 'map.mapItemEdit');
	return array(null, $tpl, 'modules_map');
    }

    /**
     * @see ItemEditPlugin::isSupported
     */
    function isSupported($item, $thumbnail) {
	if (GalleryUtilities::isA($item, 'GalleryAlbumItem')) {
	    return true;
	}
	list ($ret, $param) = mapHelper::loadParameters($item->getParentId());
          if ($ret) {
               return false;
          }
	if (!empty($param['common']) ||
	    (GalleryUtilities::isA($item, 'GalleryPhotoItem') && !empty($param['photo']))) {
	    return true;
	}
	return false;
    }

    /**
     * @see ItemEditPlugin::getTitle
     */
    function getTitle() {
        global $gallery;
	list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
        if ($ret) {
              return $ret->wrap(__FILE__, __LINE__);
        }
	return array(null, $gallery->i18n('Google Map'));
    }
}
?>