<?php
/*
 * $RCSfile: module.inc,v $Revision: 1.55 $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @version 0.5.1d
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 *
 */

/**
 * Map
 *
 * This module provides Google Map for Gallery items.
 *
 * @package map
 */
class mapModule extends GalleryModule {

    function mapModule() {
	global $gallery;
	$this->setId('map');
	$this->setName($gallery->i18n('Google Map Module'));
	$this->setDescription($gallery->i18n('Show item on a Google Map Using the API'));
	$this->setVersion('0.5.1d');
	$this->setGroup('gallery', $gallery->i18n('Gallery'));
	$this->setCallbacks('registerEventListeners|getSiteAdminViews|getItemSummaries|getItemLinks');
	$this->setRequiredCoreApi(array(7, 0));
	$this->setRequiredModuleApi(array(3, 0));
    }

    /**
     * @see GalleryModule::registerEventListeners()
     */
    function registerEventListeners() {
	GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
	GalleryCoreApi::registerEventListener('GalleryEntity::delete', new mapHelper());
    }

    /**
     * @see GalleryModule::autoConfigure
     */
    function autoConfigure() {
        GalleryCoreApi::setPluginParameter('module', 'map', 'googleMapKey', '');
        GalleryCoreApi::setPluginParameter('module', 'map', 'mapWidth', 600);
        GalleryCoreApi::setPluginParameter('module', 'map', 'mapHeight', 400);
        GalleryCoreApi::setPluginParameter('module', 'map', 'centerLongLat', '0,0');
        GalleryCoreApi::setPluginParameter('module', 'map', 'zoomLevel', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'zoomInLevel', 12);
        GalleryCoreApi::setPluginParameter('module', 'map', 'mapType', "G_SATELLITE_TYPE");
        GalleryCoreApi::setPluginParameter('module', 'map', 'showZoomScale', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'showMapType', 1);
        GalleryCoreApi::setPluginParameter('module', 'map', 'showZoomLinks', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'showItemSummaries', 1);
        GalleryCoreApi::setPluginParameter('module', 'map', 'showItemDescriptions', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'regroupAlbums', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'regroupItems', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'regroupDist', 15);
        GalleryCoreApi::setPluginParameter('module', 'map', 'regroupIcon', 'zoom-in-trans');
        GalleryCoreApi::setPluginParameter('module', 'map', 'useMarkerSet', 'smallpushpins');
        GalleryCoreApi::setPluginParameter('module', 'map', 'useAlbumMarkerSet', 'smallpushpins');
        GalleryCoreApi::setPluginParameter('module', 'map', 'useGroupMarkerSet', 'smallpushpins');
        GalleryCoreApi::setPluginParameter('module', 'map', 'defaultphotocolor', 'GREEN');
        GalleryCoreApi::setPluginParameter('module', 'map', 'defaultalbumcolor', 'YELLOW');
        GalleryCoreApi::setPluginParameter('module', 'map', 'defaultgroupcolor', 'RED');
        GalleryCoreApi::setPluginParameter('module', 'map', 'useParentColor', 0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'GxMagnifier',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'GxMagnifier2',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'MapControlType','Small');
        GalleryCoreApi::setPluginParameter('module', 'map', 'MapControlPos','0');
        GalleryCoreApi::setPluginParameter('module', 'map', 'MapControlPosOffX','10');
        GalleryCoreApi::setPluginParameter('module', 'map', 'MapControlPosOffY','15');
        GalleryCoreApi::setPluginParameter('module', 'map', 'AutoCenterZoom',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ShowExportGELink',1);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ExpandAlbumLegend',1);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ExpandPhotoLegend',1);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ShowFilters',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'LegendPos',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'GxMagnifierFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ThemeFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'MarkerFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'LegendFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'FilterFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'GroupFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'RouteFeature',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ThumbBarPos',0);
        GalleryCoreApi::setPluginParameter('module', 'map', 'ThumbHeight',60);
        GalleryCoreApi::setPluginParameter('module', 'map', 'linktype',0);
	list($ret,$exifModule) = GalleryCoreApi::loadPlugin("module","exif",false);
	if ($ret) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
	}else{
          if (!version_compare ("1.0.1",$exifModule->getVersion(),"<="))
          {
            GalleryCoreApi::setPluginParameter('module', 'map', 'oldexifversion',1);
          } else {
            GalleryCoreApi::setPluginParameter('module', 'map', 'oldexifversion',0);
          }
        }
	list($ret,$imagemagickModule) = GalleryCoreApi::loadPlugin("module","imagemagick",false);
	if ($ret) {
	    return $ret->wrap(__FILE__, __LINE__);
	}else{
          if (empty($imagemagickModule))
  	  {
            GalleryCoreApi::setPluginParameter('module', 'map', 'noimagemagick',1);
          } else {
            GalleryCoreApi::setPluginParameter('module', 'map', 'noimagemagick',0);
          }
        }
        return array(null, true);
    }

    function needsConfiguration() {
	/* This module requires a Google Map API key. */
        list ($ret, $value) = $this->getParameter('MapKeys');
        if ($ret) {
   	    return array($ret->wrap(__FILE__, __LINE__), null);
        }
        if (empty($value) or $value == "") {
		return array(null, true);
	    }
	return array(null, false);
    }

    function activate($postActivationEvent=true){

          $base = substr(dirname(__FILE__),0,-11);
          $urltmp  = parse_url(GalleryUtilities::convertPathToUrl($base));
          $url = $urltmp['path'];

          GalleryCoreApi::setPluginParameter('module', 'map', 'gallerybase',$base);
          GalleryCoreApi::setPluginParameter('module', 'map', 'urlbase',$url);
          GalleryCoreApi::setPluginParameter('module', 'map', 'GxMagnifierPath',$url.'modules/map/GxMagnifier/');

          list ($ret, $redirect) = parent::activate($postActivationEvent);
          if ($ret) {
      	   return array($ret->wrap(__FILE__, __LINE__), null);
          }

	  return array(null, $redirect);

    }

    function getConfigurationView() {
	return 'map.MapSiteAdmin';
    }

    /**
     * @see GalleryModule::getSiteAdminViews()
     */
    function getSiteAdminViews() {
	global $gallery;
        return array(null,
		     array(array('name' => $gallery->i18n('Google Map'),
				 'view' => 'map.MapSiteAdmin')));
    }

    /**
     * @see GalleryModule::getItemSummaries()
     */
    function getItemSummaries($items, $permissions) {
	GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
	GalleryCoreApi::requireOnce('lib/smarty_plugins/modifier.markup.php');
	$summaries = array();

	list ($ret, $data) = mapHelper::fetchFieldValues($items, 'summary');
         if ($ret) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
         }

	foreach ($data as $itemId => $fields) {
	    $list = array();
	    foreach ($fields as $field => $value) {
		$list[] = $field . ': ' . smarty_modifier_markup($value);
	    }
	    if (!empty($list)) {
		$summaries[$itemId] = implode("<br/>\n", $list);
	    }
	}
	return array(null, $summaries);
    }

    /**
     * @see GalleryModule::getRewriteRules()
     */
    function getRewriteRules() {
        global $gallery;
        $rules = array();

        $rule=array();
        $rule['comment']='View Google Map Group';
        $rule['match']=array('view' => 'map.ShowMap');
        $rule['pattern']='Map/%Group%';
	$rule['keywords'] = array(
	    'Group' => array(
		'pattern' => '(G{1}[0-9]+)*',
		'help' => $gallery->i18n('The ID of the group to show, No group will show the default Map')));
        $rules[0]=$rule;

        return $rules;
    }

    /**
     * @see GalleryModule::performFactoryRegistrations()
     */
    function performFactoryRegistrations() {
	/* Register our item edit plugin */
	$ret = GalleryCoreApi::registerFactoryImplementation(
	    'ItemEditPlugin', 'mapItemEdit', 'mapItemEdit',
	    'modules/map/mapItemEdit.inc', 'map', null);
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
        }

	/* Register interface implementation */
	$ret = GalleryCoreApi::registerFactoryImplementation(
	    'mapInterface_1_0', 'mapHelper', 'map',
	    'modules/map/classes/mapHelper.class', 'map', null);
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
        }

	/* Register search implementation */
	$ret = GalleryCoreApi::registerFactoryImplementation(
	    'GallerySearchInterface_1_0', 'mapSearch', 'map',
	    'modules/map/classes/mapSearch.class', 'map', null);
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
        }

	return null;
    }

    /**
     * @see GalleryModule::getItemLinks()
     */
    function getItemLinks($items, $wantsDetailedLinks, $permissions) {
        global $gallery;
        GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
        $links = array();

        list($ret,$linktype) = GalleryCoreApi::getPluginParameter('module', 'map', 'linktype');
        if (empty($linktype)) $linktype = 0;
        list ($ret, $ExportGELink) = GalleryCoreApi::getPluginParameter ('module','map','ShowExportGELink');
        foreach ($items as $item) {
          $itemId = $item->getId();
          $type = $item->getEntityType();
          //The Export to GE Link (only for album and only if enabled in the Panel)
          if ($item->getCanContainChildren() and $ExportGELink) {
              $links[$itemId][] =
                  array('text' => $gallery->i18n('Export to GE'),
                        'params' => array (
                            'view' => 'map.GoogleEarthAlbum',
                            'itemId' => $itemId));
          }
          if ($type == "GalleryPhotoItem") $NitemId = $item->getParentId();
          else $NitemId = $itemId;
          list($ret, $item)=GalleryCoreApi::loadEntitiesById($NitemId);
          $name = $item->getTitle();

          $goodalbum  = false;
          list ($ret,$TheRoot) = GalleryCoreApi::getPluginParameter('module','core','id.rootAlbum');
          if ($linktype == 2) $goodalbum = true; //Always filter on current album

          if ($item->getId() != $TheRoot and $linktype == 1){ //Dynamic link -> search for item in the album/subalbum with GPS coords
            list ($ret, $allitemsids) = GalleryCoreApi::fetchDescendentItemIds($item);
            list ($ret, $allitems) = GalleryCoreApi::loadEntitiesById($allitemsids);
            list ($ret, $itemcoords) = mapHelper::fetchFieldValues($allitems);
  
            if (!empty($itemcoords)){
              foreach ($itemcoords as $id => $items){
                if (empty($items)) unset($itemcoords[$id]);
              }
              if (!empty($itemcoords)) $goodalbum = true;
            }
          }
          //The Google Map link
          if (isset($wantsDetailedLinks[$itemId])) {
            if ($goodalbum) {
              $links[$itemId][] =
                   array('text' => $this->translate('View Album on a Map'),
                         'params' => array('view' => 'map.ShowMap','Mode' => 'Normal', 'Group' => '', 'album' => $name));
            } else { //the current album (or parent of the current photo does not have any GPS item , show a link to the default map
              $links[$itemId][] =
                  array('text' => $this->translate('Show a Google Map'),
                        'params' => array('view' => 'map.ShowMap'));
            }
          }
        }
        return array(null, $links);
    }

    function upgrade($currentversion) {
        global $gallery;
        $storage =& $gallery->getStorage();

  	list($ret,$exifModule) = GalleryCoreApi::loadPlugin("module","exif",false);
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
	}else {
            GalleryCoreApi::setPluginParameter('module', 'map', 'oldexifversion',0);
	    if (!version_compare ("1.0.1",$exifModule->getVersion(),"<="))
	    {
              GalleryCoreApi::setPluginParameter('module', 'map', 'oldexifversion',1);
            }
        }
	list($ret,$imagemagickModule) = GalleryCoreApi::loadPlugin("module","imagemagick",false);
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
	} else {
        GalleryCoreApi::setPluginParameter('module', 'map', 'noimagemagick',0);
        }

	if (ctype_alpha(substr($currentversion,-1,1))) $currentVersion = substr($currentversion,0,-1);
        else $currentVersion = $currentversion;
        $LcurrentVersion = $currentVersion;
        if (strlen($currentVersion) > 5) $currentVersion = substr($currentVersion,0,4)."9";

        if (isset($currentversion) and $currentversion != "0"){
         if ($currentVersion <= "0.3.2" AND $currentVersion > "0"){  //Upgrade from when we were using CustomField

           //get CustomfieldMap table fields related to Map
           $query='
            SELECT *
            FROM [GalleryCustomFieldMap]
            WHERE [GalleryCustomFieldMap::field] = \'GPS\'
            OR [GalleryCustomFieldMap::field] = \'Colors\'
            OR [GalleryCustomFieldMap::field] = \'Color\'
            OR [GalleryCustomFieldMap::field] = \'ZoomLevel\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){
                if ($result[1] == "Color") $result[1] = "Colors";       //Replace the "color" field for "colors"

                $insertquery='
                   INSERT INTO
                   [GallerymapMap]
                   VALUES (\''.$result[0].'\',\''.$result[1].'\',\''.$result[2].'\',\''.$result[3].'\',\''.$result[4].'\')
                   ';
    
                $ret = $storage->execute($insertquery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         }
         if ($currentVersion < "0.4.5" AND $currentVersion > "0.4.0") { //Upgrade from before the routes were able to be filters
            //Get the Routes field
            $routes = GalleryCoreApi::getPluginParameter ('module','map','Routes');
            $newroutes=array();

            //Update with new parameters set to no
            if (!empty($routes[1])){  //There is some routes, upgrading
              $allroutes = explode ("|",$routes[1]);
              foreach ($allroutes as $route)
              {
                $usingnewroutes = strpos($route,"`Yes`No") ? 1:0 + strpos($route,"`Yes`Yes") ? 1:0 + strpos($route,"`No`Yes") ? 1:0 + strpos($route,"`No`No") ? 1:0;
                $posyes = strpos($route,"`Yes");
                $posno = strpos($route,"`No");
                if ($posyes and $usingnewroutes==0) {
                  $newroutes[]= substr($route,0,$posyes+4)."`No".substr($route,$posyes+4)."<br>";
                } elseif ($posno and $usingnewroutes==0) {
                  $newroutes[] = substr($route,0,$posno+3)."`No".substr($route,$posno+3)."<br>";
                }
              }
             if ($newroutes != "1")  {
               $theroutes=implode("|",$newroutes);
               GalleryCoreApi::setPluginParameter ('module','map','Routes',$theroutes);       //Set the new routes in the database
             }
            }
         }

         if ($currentVersion < "0.4.5"){          //copy markers to the module directory (we don't care if that fails)
           $basegallerydir = substr(dirname(__FILE__),0,-11);
           GalleryCoreApi::requireOnce('modules/map/classes/filecopy.class');
           @CopyDir($basegallerydir.'../images/map',$basegallerydir.'map/images/markers',0777,false);
           @rm($basegallerydir.'images/map');
         }

         if ($currentVersion < "0.4.5" AND $currentVersion > "0.4.0"){   //Upgrade routes to be pointing to Item instead of coordinates of items
            //Get current routes
            list ($ret,$routes) = GalleryCoreApi::getPluginParameter ('module','map','Routes');
            $newroutes = "";
            if (!empty($routes)) //there is some route, fix them :-)
            {
             $allroutes = explode ("|",$routes);
             foreach ($allroutes as $route) //go throught each route
             {
               $routeinfos = explode ("`",$route);
               $theroute = $routeinfos[0].'`'.$routeinfos[1].'`'.$routeinfos[2].'`'.$routeinfos[3].'`'.$routeinfos[4].'`'.$routeinfos[5].'`'.$routeinfos[6];
               for ($i=7; $i<count($routeinfos); $i++)
               {
                 $query = '                                            //Search for the itemid from the coordinate and replace
                  SELECT [GallerymapMap::itemId]
                  FROM [GallerymapMap]
                  WHERE [GallerymapMap::value] = \''.$routeinfos[$i].'\'
                  ';
                  list ($ret, $results) = $storage->search($query);
                  if ($results->resultCount > 0) {
                    $result = $results->nextResult();
                    $theroute .= '`'.$result[0];
                  }
                  else {
                    $theroute .= "`".$routeinfos[$i];
                  }
               }
               if ($newroutes == "") $newroutes = $theroute;
               else $newroutes .= "|".$theroute;
             }
             GalleryCoreApi::setPluginParameter ('module','map','Routes',$newroutes);   //Replace route with new infos
            }
         }
         if ($currentVersion > "0.3.2" and $currentVersion < "0.4.8"){ //attempt to change the database itemId from int to varchar

          $query = "ALTER TABLE [GallerymapMap]
          CHANGE [GallerymapMap::itemId]
          [GallerymapMap::itemId] VARCHAR(11) DEFAULT '0' NOT NULL";

          $ret = $storage->execute($query);      //put the values in mapMap
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }
         }
	 if ($currentVersion < '0.5.0'){
	    $ret = $storage->configureStore($this->getId(), array('mapMap:1.2'));
	    if ($ret) return $ret->wrap(__FILE__, __LINE__);
	 }
	 if ($currentVersion < "0.5.1"){
	// Reverse the existing 'GPS' coordinatesin the DB ********************************
           $query='
            SELECT *
            FROM [GallerymapMap]
            WHERE [GallerymapMap::field] = \'GPS\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[2])) {
			$tempcoord=explode(",",$result[2]);
			$result[2] = "$tempcoord[1],$tempcoord[0]";
		}

                  $updatequery='
                        UPDATE [GallerymapMap]
                                SET [GallerymapMap::value] = \''.$result[2].'\'
                                WHERE [GallerymapMap::itemId] = \''.$result[0].'\'
                                AND [GallerymapMap::field] = \''.$result[1].'\'
                                AND [GallerymapMap::setId] = \''.$result[3].'\'
                                AND [GallerymapMap::setType] = \''.$result[4].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End reversing GPS coordinates in DB *********************************************

	 // Update map type ****************************************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'mapType\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			if ($result[4] == 'G_MAP_TYPE') $result[4] = 'G_NORMAL_MAP';
			if ($result[4] == 'G_SATELLITE_TYPE') $result[4] = 'G_SATELLITE_MAP';
			if ($result[4] == 'G_HYBRID_TYPE') $result[4] = 'G_HYBRID_MAP';

		}

                  $updatequery='
                        UPDATE [PluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End updating the Map Type in the DB  ********************************************

	// Reverse the Map Center parameter ************************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'centerLongLat\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			$tempcoord=explode(",",$result[4]);
			$result[4] = "$tempcoord[1],$tempcoord[0]";
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End reversing the coordinates in the Map Center Paramater *******************

      	 // Reverse the Default Map Center parameter ***********************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'GVMCenter\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			$tempcoord=explode(",",$result[4]);
			$result[4] = "$tempcoord[1],$tempcoord[0]";
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End reversing the coordinates in the Default Map Center Paramater ***********

      	 // Updating the Zoom Level ****************************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'zoomLevel\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			$result[4] = 17- $result[4];
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End updating the Map Zoom ***************************************************

      	 // Updating the Default Zoom Level ********************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'GVMZoom\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			$result[4] = 17- $result[4];
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End updating the Default Map Zoom ******************************************

      	 // Updating the Default ZoomIn Level *****************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'zoomInLevel\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) {
			$result[4] = 17- $result[4];
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End updating the Default Map ZoomIn ****************************************

         // Updating the Manual Filter information ************************************
           $query='
            SELECT *
            FROM [GalleryPluginParameterMap]
            WHERE [GalleryPluginParameterMap::pluginType] = \'module\'
            AND [GalleryPluginParameterMap::pluginId] = \'map\'
            AND [GalleryPluginParameterMap::parameterName] = \'Filters\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount() > 0) {             //Verify that it isn't empty
              while ($result = $results->nextResult()){


		if (!empty($result[4])) { //we do have some filters, start the upgrade
		  $filterarray = explode("|",$result[4]);
		  foreach ($filterarray as $key => $filterinfos){
                    $infos = explode("`",$filterinfos);
                    $tempcenter = explode(",",$infos[3]);
                    $infos[3] = $tempcenter[1].",".$tempcenter[0];  //invert the coordinates for this filter
                    $infos[2] = 17 - $infos[2];  // change the zoom for this filter
                    $filterarray[$key] = implode ("`",$infos);  //put the new infos back into the original array
                  }
                  $result[4] = implode("|",$filterarray); //put all the fixed filter into the result
		}

                  $updatequery='
                        UPDATE [GalleryPluginParameterMap]
                                SET [GalleryPluginParameterMap::parameterValue] = \''.$result[4].'\'
                                WHERE [GalleryPluginParameterMap::pluginType] = \''.$result[0].'\'
                                AND [GalleryPluginParameterMap::pluginId] = \''.$result[1].'\'
                                AND [GalleryPluginParameterMap::itemId] = \''.$result[2].'\'
                                AND [GalleryPluginParameterMap::parameterName] = \''.$result[3].'\'
                        ';

                $ret = $storage->execute($updatequery);      //put the values in Mapmap
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

              }
            }
         //End updating the Manual Filter Information  ********************************
         }
        }

        return null;
    }

 }
?>